

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include <errno.h>
#include "mgu.h"

/* Transmit a byte. */
int txabyte(int byte)
{
	int j, rdb;
	unsigned int mask, br;

	/* Check that the GPIO26 is 0 */
	do
	{
		rdb = readgpiovalue(26); 
		printf("Read g26 = %d\n", rdb); 
	}
	while(rdb > 0); 

	/* For 8 bits:
		bit to GPIO13
		pulse GPIO19 L-H-L
		Send out MSB first 
	*/

	mask = 0x80;
	for(j = 0; j<8; j++)
	{
		setgpiovalue(13, byte & mask ? 1 : 0);
		setgpiovalue(19, 1);
		setgpiovalue(19, 0);
		mask >>= 1;
	}

	/* Pulse GPIO16 L-H-L */
	setgpiovalue(16, 1);
	setgpiovalue(16, 0);

	return(1);
}

/* Receive a byte. */
int checkbyte()
{
	/* Check GPIO21, do we have any data? */
	return readgpiovalue(21); 
}

int rxabyte()
{
	int j, hasd; 
	int bfound, rx;
	unsigned int mask, bacc;

	/* To be sure... */
	setgpiovalue(20, 1);

	do
	{
		/* Check GPIO21, do we have any data? */
		hasd  = readgpiovalue(21); 
		printf("Read g26 = %d\n", hasd); 
	}
	while(hasd == 0); 

	/* Yes, we have stuff. Hit on the LS165. */

	/* Pulse GPIO12, Latch enable, H-L-H */
	setgpiovalue(12, 1);
	setgpiovalue(12, 0);
	setgpiovalue(12, 1);

	/* Data line has the MSB now. */ 
	bacc = 0; 
	mask = 0x80;
	for(j = 0; j<8; j++)
	{
		rx = readgpiovalue(6); 
		if(rx == 1)
		{
			bacc |= mask;
		}
		/* Shift and pass the rest of them */ 
		mask >>= 1;

		/* Clock */
		setgpiovalue(5, 0);
		setgpiovalue(5, 1);
	}
	bfound = bacc;

	/* Pulse GPIO20 H-L-H to reset. */
	setgpiovalue(20, 1);
	setgpiovalue(20, 0);
	setgpiovalue(20, 1);
	return(bfound); 
}





