
/* kbhit.c -- kbhit.c for Linux 
	Uses termios(3) and select(2)
*/

#include <stdio.h>
#include <fcntl.h>
#include <termios.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

int rawin()
{
	int hh = 0;
	struct termios sb;

	tcgetattr(hh, &sb);
	sb.c_lflag &= ~(ECHO | ICANON); 
	tcsetattr(hh, TCSANOW, &sb);
	return(hh);	
}

int norawin()
{
	int hh = 0;
	struct termios sb;

	/* Turn off RAW and NDELAY */
	tcgetattr(hh, &sb);
	sb.c_lflag |= (ECHO | ICANON);
	tcsetattr(hh, TCSANOW, &sb);
	return(hh);
}


int kbhit()
{
	fd_set rdfs;
	struct timeval T0;
	int bs;

	FD_ZERO(&rdfs);
	FD_SET(0, &rdfs);
	T0.tv_sec = 0;
	T0.tv_usec = 5000;	 /* 5 milliseconds.... */

	bs = select(1, &rdfs, NULL, NULL, &T0);
	if(bs < 0)
	{
		perror("Select stdin");
		return(0);
	}

	if(FD_ISSET(0, &rdfs)) return(1);

	return(0);
}

/* Get a character. Will block if kbhit returned 0 */
int getch()
{
	int nrd;
	char txt[4];
	nrd = read(0, txt, 1);
	if(nrd > 0)
	{
		return( (txt[0]) & 0x00FF );
	}
	return(-1);
}

/* Raw-mode get-function, with echo. Both TC and Xenix except as noted */
/* int kbgets(txt, tmax) char *txt; int tmax; */

#if(0)

main()
{
	char txt[90];
	int j, c;

	rawin();

	j = 0;

	for(;;)
	{
		if(kbhit())
		{
			c = getch();
			/* printf("\nGot char = %d\n", c); */
			txt[j] = c;
			j++;
			if(c == '$' || j > 80) break;
		}
	}
	txt[j] = 0;

	norawin();

	printf("Read: %s\n", txt);
	return(0);
}

#endif









