
/* mgu.c -- gpio functions */ 


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <poll.h>
#include <signal.h>
#include <math.h>

#include "mgu.h"

/* Write a value to one if the gpio files */
int writegpiofile(char *file, char *value)
{
    FILE *fp;
    fp = fopen(file, "w");
    if(!fp) return(-1);

    fprintf(fp, "%s\n", value);
    fclose(fp);
    return(strlen(value));
}

/* Write nvalue to the gpio number value file to set it on or off. */ 
int setgpiovalue(int gpiono, int nvalue)
{
	char thefile[256];
    FILE *fp;
	snprintf(thefile, 256, "/sys/class/gpio/gpio%d/value", gpiono); 
    fp = fopen(thefile, "w");
    if(!fp) return(-1);

    fprintf(fp, "%d\n", nvalue);
    fclose(fp);
    return(nvalue);
}



/* Read current state of one of the gpio files */
int readgpiofile(char *file, char *readval, size_t rvmax)
{
    FILE *fp;

    fp = fopen(file, "r");
    if(!fp) return(-1);
    fgets(readval, rvmax, fp);

    fclose(fp);
    return(strlen(readval));
}


/* Read current state of one of the gpio files - return numerical value */
int readgpiovalue(int gpiono)
{
	char thefile[256];
    FILE *fp;
	char readval[20];
	int nv;

	snprintf(thefile, 256, "/sys/class/gpio/gpio%d/value", gpiono); 

    fp = fopen(thefile, "r");
    if(!fp) return(-1);
    fgets(readval, 20, fp);
    fclose(fp);
	nv = strtol(readval, NULL, 0); 
	return(nv); 
}


