

/* mgu.h -- functions for start/stop/run the motors. */
#ifndef MGUHINCLUDED
#define MGUHINCLUDED

/* Write a value to one if the gpio files */
int writeto(char *file, char *value);

/* Write nvalue to the gpio number value file to set it on or off. */ 
int setgpio(int gpiono, int nvalue);


/* Read current state of one of the gpio files */
int readfrom(char *file, char *readval, size_t rvmax);

/* Left motor:						Right motor:
	G17=0 stop 1 go					G10=0 stop 1 go
    G04=0 back 1 forward            G25=0 back 1 forward
*/ 
#define LGO 17
#define LDIR 4
#define RGO 10
#define RDIR 25
#define GFWD 1
#define GBACK 0

void mstop();

/* Impulses in specified direction with a duration */
void mimpL(int duration, int direction);
void mimpR(int duration, int direction);
void mimpLR(int durL, int durR, int direction);


/* Impulses with signed duration, sign for direction
	positive duration is forward, negative duration
	is backwards. */ 

void mimpLs(int duration);
void mimpRs(int duration);
void mimpLRs(int durL, int durR);


/* Go straight for some number of wheel-ticks, ireq. 
	Tries best it can to make left and right run the same number
	of ticks. 20 ticks is a revolution of the wheels. Returns
	the number having been travelled by the wheels, as *plt and *prt.
*/ 
int go_straight(int ireq, int *plt, int *prt);


#endif






