

/* sem1.c -- deal with semafores, leaving all the funny names here. */ 

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include "sem1.h"

/* We should be able to see which semafores exist in 
	/proc/sysvipc/sem
*/ 

/* Create an array of scount semafores. */ 
int sem_create(int key, int scount)
{
	int j, semid; 

	// semid = semget(IPC_PRIVATE, scount,  0666 | IPC_CREAT); 
	semid = semget(key, scount,  0666 | IPC_CREAT); 
	if(semid < 0)
	{
		return(semid); 
	}
	
	/* The semafores start life held, so let us release them right away. */ 
	for(j = 0; j<scount; j++)
	{
		sem_V(semid, j);
	}
	return(semid); 
}

/* Get the an array of semafores corresponding to the given key. */ 
int sem_get(int key, int scount)
{
	int semid; 

	semid = semget(key, scount,  0666); 
	return(semid); 
}


/* Delete the semafore array. */ 
int sem_delete(int semid)
{
	int bs; 
	bs = semctl(semid, 0, IPC_RMID, 0); 
	return(bs); 
}


/* Get semafor, P (Probieren) */ 
int sem_P(int semid, int semnum)
{
	struct sembuf opx; 
	int rx;

	opx.sem_num = semnum;
	opx.sem_op = -1; /* P, get */ 
	opx.sem_flg = SEM_UNDO; 
	rx = semop(semid, &opx, 1); 

	return(rx);
}

/* release semafor, V (Vrijgeben) */ 
int sem_V(int semid, int semnum)
{
	struct sembuf opx; 
	int rx;

	opx.sem_num = semnum;
	opx.sem_op = 1; /* V, release */ 
	opx.sem_flg = SEM_UNDO; 
	rx = semop(semid, &opx, 1); 

	return(rx);
}


